1.两数之和

Posted 炫云云

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了1.两数之和相关的知识,希望对你有一定的参考价值。

1.两数之和

1.两数之和

15. 三数之和

18. 四数之和

20、n数之和

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。

示例 2:

输入:nums = [3,2,4], target = 6
输出:[1,2]

哈希表

我们创建一个哈希表,对于每一个 x,我们首先查询哈希表中是否存在 target - x,如果存在,那么我们就寻找到了两个数。 题目要求我们返回数组的下标,那么我们的hash表的key是数组元素的值,value是下标。

如果不存在,将 x 插入到哈希表中,即可保证不会让 x 和自己匹配。

时间复杂度O(n),空间复杂度O(n)

class Solution(object):
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        hashtable = dict()
        for i ,num in enumerate(nums):
            # ② dict 中查找是否有 target - curvalue的数据
            if target - num in hashtable:
                return [hashtable[target - num],i]# i 是后一个数的index,因为要存入hashtable才能返回hashtable[target - num]
            # ① 数组中的每个数放入 dict 中
            hashtable[nums[i]] =i

暴力枚举

最容易想到的方法是枚举数组中的每一个数 x,寻找数组中是否存在 target - x

当我们使用遍历整个数组的方式寻找 target - x 时,需要注意到每一个位于 x 之前的元素都已经和 x 匹配过,因此不需要再进行匹配。而每一个元素不能被使用两次,所以我们只需要在 x 后面的元素中寻找 target - x

class Solution(object):
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        n = len (nums)
        for i in range(n):
            for j in range(i+1 , n):
                if nums[i] + nums[j] == target:
                    return [i,j]
        return []

排序+双指针法

这里先将数组排序好O(nlogn),再利用双指针法遍历一遍O(n)得到结果。

为了保存下标信息另开了一个数组

时间复杂度O(nlogn),空间复杂度O(n)

class Solution(object):
    def twoSum(self, nums, target):
        """
        :type nums: List[int]
        :type target: int
        :rtype: List[int]
        """
        temp=nums.copy() # 避免sort()修改nums里的内容
        temp.sort()
        lo,hi = 0,len(nums) -1
        while(lo<hi):
            sums = temp[lo] +temp[hi]
            if(sums<target): 
                lo+=1
            elif(sums>target): 
                hi-=1
            else:
                break
        p=nums.index(temp[lo])
        #在执行完p=nums.index(temp[lo])后需要把p的值从nums中删除,避免nums中相等的值产生干扰。
        nums.pop(p)
        k=nums.index(temp[hi])
        if k>=p:
            #由于nums的元素少了一个,所以当k>=p时,K需要加一才是正确的索引值
            k=k+1
        return [p,k]

参考

Krahets - 力扣(LeetCode) (leetcode-cn.com)

以上是关于1.两数之和的主要内容,如果未能解决你的问题,请参考以下文章

LeetCode:两数之和

LeetCode第5天 - 283. 移动零 | 167. 两数之和 II - 输入有序数组

数组练习题:两数之和三数之和四数之和

LeetCode 1两数之和

LeetCode——1.两数之和

两数之和